Package de.willuhn.jameica.hbci.passports.rdh.server

# Class RDHKeyImpl

java.lang.Object
de.willuhn.jameica.hbci.passports.rdh.server.RDHKeyImpl

All Implemented Interfaces:
  `de.willuhn.datasource.GenericObject`, `Configuration`, `RDHKey`, `Remote`

public class RDHKeyImpl extends Object implements RDHKey
Implementierung eines in Hibiscus existierenden RDH-Schluessels.

## Constructor Summary

Constructors
Constructor
Description
`RDHKeyImpl(File file)`
ct.

## Method Summary

Modifier and Type
Method
Description
`void`
`delete()`
Loescht die Konfiguration.
`boolean`
`equals(de.willuhn.datasource.GenericObject other)`
`String`
`getAlias()`
Liefert einen optionalen Alias-Namen fuer den Schluessel.
`Object`
`getAttribute(String attribute)`
`String[]`
`getAttributeNames()`
`Class`
`getConfigDialog()`
Liefert die Klasse des Konfigurationsdialogs.
`String`
`getDescription()`
Liefert einen Beschreibungstext fuer die Konfiguration.
`String`
`getFilename()`
Liefert Pfad- und Dateiname des Schluessels.
`String`
`getHBCIVersion()`
Liefert die HBCI-Version des Schluessels.
`String`
`getID()`
`Konto[]`
`getKonten()`
Liefert eine optionale Liste von hart verdrahteten Konten.
`String`
`getPrimaryAttribute()`
`boolean`
`isEnabled()`
Prueft, ob der Schluessel zum aktiven Datenbestand gehoert und somit benutzt werden kann.
`org.kapott.hbci.passport.HBCIPassport`
`load()`
Liefert den Passport des Schluessels.
`void`
`setAlias(String alias)`
Speichert einen zusaetzlichen Alias-Namen fuer den Schluessel.
`void`
`setEnabled(boolean enabled)`
Aktiviert oder deaktiviert den Schluessel fuer die Verwendung.
`void`
`setFilename(String filename)`
Speichert den Pfad- und Dateinamen des Schluessels.
`void`
`setFormat(KeyFormat format)`
Speichert das Format des Schluessels.
`void`
`setHBCIVersion(String version)`
Speichert die zu verwendende HBCI-Version.
`void`
`setKonten(Konto[] k)`
Speichert eine optionale Liste von festzugeordneten Konten.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### RDHKeyImpl

public RDHKeyImpl(File file) throws RemoteException
ct.

Parameters:
  `file` - Die Schluesseldatei.
Throws:
  `RemoteException`

## Method Details

### getAttribute

public Object getAttribute(String attribute) throws RemoteException

Specified by:
  `getAttribute` in interface `de.willuhn.datasource.GenericObject`
Throws:
  `RemoteException`
See Also:
  - `GenericObject.getAttribute(java.lang.String)`

### getDescription

public String getDescription()
Description copied from interface: `Configuration`
Liefert einen Beschreibungstext fuer die Konfiguration.

Specified by:
  `getDescription` in interface `Configuration`
Returns:
  Beschreibungstext.
See Also:
  - `Configuration.getDescription()`

### getConfigDialog

public Class getConfigDialog() throws RemoteException
Description copied from interface: `Configuration`
Liefert die Klasse des Konfigurationsdialogs. Oeffnet der Anwender den Konfigurations-Dialog durch Doppelklick auf die Liste der vorhandenen Konfigurationen, dann wird eine Instanz dieser Klasse erzeugt und in der GUI angezeigt. Als Referenz kann hierzu de.willuhn.jameica.passports.ddv.View dienen.

Specified by:
  `getConfigDialog` in interface `Configuration`
Returns:
  Die Klasse des Konfig-Dialogs. Muss von `AbstractView` abgeleitet sein.
Throws:
  `RemoteException`
See Also:
  - `Configuration.getConfigDialog()`

### delete

public void delete() throws de.willuhn.util.ApplicationException
Description copied from interface: `Configuration`
Loescht die Konfiguration.

Specified by:
  `delete` in interface `Configuration`
Throws:
  `de.willuhn.util.ApplicationException`
See Also:
  - `Configuration.delete()`

### getAttributeNames

public String[] getAttributeNames() throws RemoteException

Specified by:
  `getAttributeNames` in interface `de.willuhn.datasource.GenericObject`
Throws:
  `RemoteException`
See Also:
  - `GenericObject.getAttributeNames()`

### getID

public String getID() throws RemoteException

Specified by:
  `getID` in interface `de.willuhn.datasource.GenericObject`
Throws:
  `RemoteException`
See Also:
  - `GenericObject.getID()`

### getPrimaryAttribute

public String getPrimaryAttribute() throws RemoteException

Specified by:
  `getPrimaryAttribute` in interface `de.willuhn.datasource.GenericObject`
Throws:
  `RemoteException`
See Also:
  - `GenericObject.getPrimaryAttribute()`

### equals

public boolean equals(de.willuhn.datasource.GenericObject other) throws RemoteException

Specified by:
  `equals` in interface `de.willuhn.datasource.GenericObject`
Throws:
  `RemoteException`
See Also:
  - `GenericObject.equals(de.willuhn.datasource.GenericObject)`

### getFilename

public String getFilename() throws RemoteException
Description copied from interface: `RDHKey`
Liefert Pfad- und Dateiname des Schluessels.

Specified by:
  `getFilename` in interface `RDHKey`
Returns:
  Pfad- und Dateiname des Schluessels.
Throws:
  `RemoteException`
See Also:
  - `RDHKey.getFilename()`

### getHBCIVersion

public String getHBCIVersion() throws RemoteException
Description copied from interface: `RDHKey`
Liefert die HBCI-Version des Schluessels.

Specified by:
  `getHBCIVersion` in interface `RDHKey`
Returns:
  HBCI-Version des Schluessels oder null, wenn noch keine bekannt ist.
Throws:
  `RemoteException`
See Also:
  - `RDHKey.getHBCIVersion()`

### setHBCIVersion

public void setHBCIVersion(String version) throws RemoteException
Description copied from interface: `RDHKey`
Speichert die zu verwendende HBCI-Version.

Specified by:
  `setHBCIVersion` in interface `RDHKey`
Parameters:
  `version` - HBCI-Version.
Throws:
  `RemoteException`
See Also:
  - `RDHKey.setHBCIVersion(java.lang.String)`

### isEnabled

public boolean isEnabled() throws RemoteException
Description copied from interface: `RDHKey`
Prueft, ob der Schluessel zum aktiven Datenbestand gehoert und somit benutzt werden kann.

Specified by:
  `isEnabled` in interface `RDHKey`
Returns:
  true, wenn er verwendet werden kann.
Throws:
  `RemoteException`
See Also:
  - `RDHKey.isEnabled()`

### setEnabled

public void setEnabled(boolean enabled) throws RemoteException
Description copied from interface: `RDHKey`
Aktiviert oder deaktiviert den Schluessel fuer die Verwendung.

Specified by:
  `setEnabled` in interface `RDHKey`
Parameters:
  `enabled` - true, wenn der Schluessel aktiv ist
Throws:
  `RemoteException`
See Also:
  - `RDHKey.setEnabled(boolean)`

### setFilename

public void setFilename(String filename) throws RemoteException
Description copied from interface: `RDHKey`
Speichert den Pfad- und Dateinamen des Schluessels.

Specified by:
  `setFilename` in interface `RDHKey`
Parameters:
  `filename` - Pfad- und Dateiname des Schluessels.
Throws:
  `RemoteException`
See Also:
  - `RDHKey.setFilename(java.lang.String)`

### getAlias

public String getAlias() throws RemoteException
Description copied from interface: `RDHKey`
Liefert einen optionalen Alias-Namen fuer den Schluessel.

Specified by:
  `getAlias` in interface `RDHKey`
Returns:
  Alias-Name.
Throws:
  `RemoteException`
See Also:
  - `RDHKey.getAlias()`

### setAlias

public void setAlias(String alias) throws RemoteException
Description copied from interface: `RDHKey`
Speichert einen zusaetzlichen Alias-Namen fuer den Schluessel.

Specified by:
  `setAlias` in interface `RDHKey`
Parameters:
  `alias` - Alias-Name.
Throws:
  `RemoteException`
See Also:
  - `RDHKey.setAlias(java.lang.String)`

### getKonten

public Konto[] getKonten() throws RemoteException
Description copied from interface: `RDHKey`
Liefert eine optionale Liste von hart verdrahteten Konten. Das ist sinnvoll, wenn der User mehrere Konten bei der gleichen Bank mit unterschiedlichen Dateien hat. Dann wuerde bei jeder Bank-Abfrage ein Dialog zur Auswahl der Datei kommen, weils Hibiscus allein anhand BLZ/Kundenkennung nicht mehr unterscheiden kann.

Specified by:
  `getKonten` in interface `RDHKey`
Returns:
  Liste der optionalen Konten oder `null` BUGZILLA 173 BUGZILLA 314
Throws:
  `RemoteException`
See Also:
  - `RDHKey.getKonten()`

### setKonten

public void setKonten(Konto[] k) throws RemoteException
Description copied from interface: `RDHKey`
Speichert eine optionale Liste von festzugeordneten Konten. BUGZILLA 173 BUGZILLA 314

Specified by:
  `setKonten` in interface `RDHKey`
Parameters:
  `k` - Liste der Konten.
Throws:
  `RemoteException`
See Also:
  - `RDHKey.setKonten(de.willuhn.jameica.hbci.rmi.Konto[])`

### load

public org.kapott.hbci.passport.HBCIPassport load() throws RemoteException, de.willuhn.util.ApplicationException, de.willuhn.jameica.system.OperationCanceledException
Description copied from interface: `RDHKey`
Liefert den Passport des Schluessels.

Specified by:
  `load` in interface `RDHKey`
Returns:
  der Passport.
Throws:
  `RemoteException`
  `de.willuhn.util.ApplicationException`
  `de.willuhn.jameica.system.OperationCanceledException`
See Also:
  - `RDHKey.load()`

### setFormat

public void setFormat(KeyFormat format) throws RemoteException
Speichert das Format des Schluessels.

Parameters:
  `format` - Format des Schluessels.
Throws:
  `RemoteException`